// 
// このコードは、https://demo.mescius.jp/diodocs/pdf のサンプルの一部として提供されています。
// © MESCIUS inc. All rights reserved.
// 

using System;
using System.IO;
using System.Linq;
using System.Collections.Generic;
using GrapeCity.Documents.Pdf;
using GrapeCity.Documents.Pdf.Layers;
using GrapeCity.Documents.Pdf.Annotations;
using GrapeCity.Documents.Pdf.Graphics;
using GrapeCity.Documents.Text;
using GrapeCity.Documents.Drawing;

namespace DsPdfWeb.Demos
{
    // このサンプルでは、複数のレイヤーを持つ PDF から、レイヤーとそのコンテンツを
    // 削除する方法を紹介しています。
    // このサンプルで読み込む PDF は、HousePlanAllLayers にて作成されたものです。
    public class RemoveLayers
    {
        public int CreatePDF(Stream stream)
        {
            using var fs = File.OpenRead(Path.Combine("Resources", "PDFs", "house-plan-all-layers.pdf"));
            var doc = new GcPdfDocument();
            doc.Load(fs);

            // 最後のレイヤーを除くすべてのレイヤーとそのコンテンツを削除します。
            var layers = doc.OptionalContent.Groups.Take(doc.OptionalContent.Groups.Count - 1).ToArray();
            doc.OptionalContent.RemoveLayers(true, layers);
            // 最後のレイヤーは、コンテンツを残して削除します。
            doc.OptionalContent.RemoveLayer(doc.OptionalContent.Groups[0]);

            // PDF を保存します。
            doc.Save(stream);
            return doc.Pages.Count;
        }
    }
}
